/*
 * Main.java
 *
 * Created on November 9, 2003, 12:45 PM
 */

package edu.umiacs.fmm;
import java.util.*;
import java.io.*;
/**
 *
 * @author  wpwy
 */
public class Main {
    public  static java.text.DecimalFormat f = new java.text.DecimalFormat("0.0000");
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception{
        int N=100;
        int threshold = 5;
        int p=5;
        
        Point[] x=new Point[N];
        Point[] y=new Point[N];
        double[] u = new double[N];
        //loadInput(x, y, u);
        for (int i=0; i<N; i++) {
            x[i] = new Point(Math.random(), Math.random());
            y[i] = new Point(Math.random(), Math.random());
            u[i] = Math.random();
        }
        
        
        
        FmmTree t = FmmTree.build(threshold, x, y, new Potential(p));
        double[] indirect = t.solve(u);
        double[] direct = t.solveDirect(u);
        double error = 0;
        for (int i=0; i<direct.length; i++) {
            //System.out.println(direct[i]+" "+indirect[i]);
            double tmp = Math.abs(direct[i]-indirect[i]);
            if (tmp>error)
                error=tmp;
        }
        System.out.println("Error: "+error);
        System.out.println("X");
        printPoints(x);
        System.out.println("Y");
        printPoints(y);
        System.out.println("U");
        printU(u);
        System.out.println("V");
        printU(indirect);;
        printTree(t);
    }
    private static void printTree(FmmTree t){
        //System.out.println(t.toString());
        t.print();
    }
    private static void printU(double[] u){
        for (double d:u)
            System.out.println(d);
    }
    private static void printPoints(Point[] x){
        for (Point p:x){
            System.out.println(p.getCoord().real()+" "+p.getCoord().imaginary());
        }
    }
    
    private static void loadInput(Point[] x, Point[] y, double[] u) throws Exception{
        String filename = "D:\\My Documents\\My Programming Projects\\fmmdemo-adaptive2\\input\\input.txt";
        java.io.BufferedReader fr = new java.io.BufferedReader(new java.io.FileReader(filename));
        String line = fr.readLine();//skip the "X"
        line = fr.readLine();
        int count=0;
        while (line!=null && !line.equals("Y")){
            Point p = parsePoint(line);
            x[count++]=p;
            line = fr.readLine();
        }
        line=fr.readLine();//skip the "Y"
        count=0;
        while (line!=null&&!line.equals("U")){
            Point p = parsePoint(line);
            y[count++]=p;
            line = fr.readLine();
        }
        line = fr.readLine();
        count = 0;
        while (line!=null&&!line.equals("END")){
            u[count++]=Double.parseDouble(line);
            line = fr.readLine();
        }
    }
    private static Point parsePoint(String line){
        StringTokenizer ss = new StringTokenizer(line, " ");
        Point p = new Point(Double.parseDouble(ss.nextToken()), Double.parseDouble(ss.nextToken()));
        return p;
    }
    
}
